//
//  ViewController.swift
//  app
//
//  Created by Luis Quiñones  on 10/25/19.
//  Copyright © 2019 Luis Quiñones . All rights reserved.
//

import UIKit
import CoreLocation

class HomeViewController: UIViewController {

    let transition = SlideInTransition()
    let locationManager = CLLocationManager()
    var topView: UIView?
    let defaults = UserDefaults.standard
    var eventDict: [String:Any] = [:]
    var msgCount: Int?
    var lastLocation: CLLocationCoordinate2D?
    var lastUpdateTime: Date?
    var isAnyEventActivated = false
    var activatedEvent: String?
    var numberOfMsgsToSend: Int?
    var deCaminoAlert: UIAlertController?
    let emptyContactsAlert = UIAlertController(title: "No existen contactos", message: "Debe importar los contactos a los que desea que se envíen los mensajes. Esto lo puede hacer en la sección 'Contactos'", preferredStyle: .alert)
    let alertaInmediata = UIAlertController(title:"Enviando alerta inmediata", message: "Se acaba de notificar a sus contactos que usted se encuentra en grave peligro.", preferredStyle: .alert)
    
    // MARK: - Alerts
    
    
    @IBAction func alertaInmediata(_ sender: UIButton) {
        if CLLocationManager.locationServicesEnabled() {
            print("Can send alert.")
        }
//        se encuentra en una situación de peligro.
    }
    
    // MARK: - De Camino
    @IBOutlet weak var deCaminoBtn: UIButton!
    @IBAction func deCaminoActivate(_ sender: UIButton) {
        
        if !defaults.contains(key: "contacts") {
            self.present(emptyContactsAlert, animated: true)
        }
        else if !isAnyEventActivated {
            // Pop alert
            eventDict = defaults.object(forKey: "deCamino") as! [String : Any]
            locationManager.delegate = self
            locationManager.startUpdatingLocation()
            isAnyEventActivated = true
            activatedEvent = "De camino"
            msgCount = 0
            if (eventDict["eventDuration"] as! String) != "1/2" {
                numberOfMsgsToSend = Int(eventDict["eventDuration"] as! String)!*60/Int(eventDict["msgFreq"] as! String)!
            }
            else {
                numberOfMsgsToSend = 30 / Int(eventDict["msgFreq"] as! String)!
            }
            
            deCaminoAlert = UIAlertController(title: "Alerta activada", message: "Su mensaje 'De camino' se está enviando cada \(eventDict["msgFreq"] ?? "") minutos. Usted puede extender la duración del evento o desactivarlo.", preferredStyle: .alert)

            deCaminoAlert?.addAction(UIAlertAction(title: "Extender por 30 minutos", style: .default, handler: { action in
                let msgFreq = self.eventDict["msgFreq"] as! Int
                self.numberOfMsgsToSend! += 30/msgFreq
            }))
            deCaminoAlert?.addAction(UIAlertAction(title: "Desactivar", style: .cancel, handler: { action in
                self.locationManager.stopUpdatingLocation()
                self.locationManager.delegate = nil
                self.msgCount = 0
                self.isAnyEventActivated = false
                print("De camino event deactivated.")
            }))
            
            self.present(deCaminoAlert!, animated: true)

        }
        else if activatedEvent == "De camino" {
            locationManager.stopUpdatingLocation()
            locationManager.delegate = nil
            msgCount = 0
            isAnyEventActivated = false
            deCaminoAlert?.dismiss(animated: true, completion: nil)
            print("De camino event deactivated.")
        }
        else {
            print("Event: \(String(describing: activatedEvent)) is activated.")
        }
        
    }
    
    // MARK: - Me quedé a pie

    @IBAction func aPie(_ sender: UIButton) {
        if !defaults.contains(key: "contacts") {
            self.present(emptyContactsAlert, animated: true)
        }
        else if !isAnyEventActivated {
            // Pop alert
            eventDict = defaults.object(forKey: "aPie") as! [String : Any]
            locationManager.delegate = self
            locationManager.startUpdatingLocation()
            isAnyEventActivated = true
            activatedEvent = "Me quedé a pie"
            msgCount = 0
            if (eventDict["eventDuration"] as! String) != "1/2" {
                numberOfMsgsToSend = Int(eventDict["eventDuration"] as! String)!*60/Int(eventDict["msgFreq"] as! String)!
            }
            else {
                numberOfMsgsToSend = 30 / Int(eventDict["msgFreq"] as! String)!
            }
            
            deCaminoAlert = UIAlertController(title: "Alerta activada", message: "Su mensaje '\(activatedEvent ?? "")' se está enviando cada \(eventDict["msgFreq"] ?? "") minutos. Usted puede extender la duración del evento o desactivarlo.", preferredStyle: .alert)

            deCaminoAlert?.addAction(UIAlertAction(title: "Extender por 30 minutos", style: .default, handler: { action in
                let msgFreq = self.eventDict["msgFreq"] as! Int
                self.numberOfMsgsToSend! += 30/msgFreq
            }))
            deCaminoAlert?.addAction(UIAlertAction(title: "Desactivar", style: .cancel, handler: { action in
                self.locationManager.stopUpdatingLocation()
                self.locationManager.delegate = nil
                self.msgCount = 0
                self.isAnyEventActivated = false
                print("Me quedé a pie event deactivated.")
            }))
            
            self.present(deCaminoAlert!, animated: true)

        }
        else if activatedEvent == "Me quedé a pie" {
            locationManager.stopUpdatingLocation()
            locationManager.delegate = nil
            msgCount = 0
            isAnyEventActivated = false
            deCaminoAlert?.dismiss(animated: true, completion: nil)
            print("Me quedé a pie event deactivated.")
        }
        else {
            print("Event: \(String(describing: activatedEvent)) is activated.")
        }
    }
    
    // MARK: - Ando soleá/o
    @IBAction func soleao(_ sender: Any) {
        if !defaults.contains(key: "contacts") {
            self.present(emptyContactsAlert, animated: true)
        }
        else if !isAnyEventActivated {
            // Pop alert
            eventDict = defaults.object(forKey: "soleao") as! [String : Any]
            locationManager.delegate = self
            locationManager.startUpdatingLocation()
            isAnyEventActivated = true
            activatedEvent = "Ando soleá/o"
            msgCount = 0
            if (eventDict["eventDuration"] as! String) != "1/2" {
                numberOfMsgsToSend = Int(eventDict["eventDuration"] as! String)!*60/Int(eventDict["msgFreq"] as! String)!
            }
            else {
                numberOfMsgsToSend = 30 / Int(eventDict["msgFreq"] as! String)!
            }
            
            deCaminoAlert = UIAlertController(title: "Alerta activada", message: "Su mensaje '\(activatedEvent ?? "")' se está enviando cada \(eventDict["msgFreq"] ?? "") minutos. Usted puede extender la duración del evento o desactivarlo.", preferredStyle: .alert)

            deCaminoAlert?.addAction(UIAlertAction(title: "Extender por 30 minutos", style: .default, handler: { action in
                let msgFreq = self.eventDict["msgFreq"] as! Int
                self.numberOfMsgsToSend! += 30/msgFreq
            }))
            deCaminoAlert?.addAction(UIAlertAction(title: "Desactivar", style: .cancel, handler: { action in
                self.locationManager.stopUpdatingLocation()
                self.locationManager.delegate = nil
                self.msgCount = 0
                self.isAnyEventActivated = false
                print("Ando soleá/o event deactivated.")
            }))
            
            self.present(deCaminoAlert!, animated: true)

        }
        else if activatedEvent == "Ando soleá/o" {
            locationManager.stopUpdatingLocation()
            locationManager.delegate = nil
            msgCount = 0
            isAnyEventActivated = false
            deCaminoAlert?.dismiss(animated: true, completion: nil)
            print("Me quedé a pie event deactivated.")
        }
        else {
            print("Event: \(String(describing: activatedEvent)) is activated.")
        }
    }
    
    
    // MARK: - Personalizado
    @IBAction func customEvent(_ sender: UIButton) {
        
        if !defaults.contains(key: "contacts") {
            return
        }
        else if !isAnyEventActivated {
            // Pop alert
            eventDict = defaults.object(forKey: "personalizado") as! [String : Any]
            locationManager.delegate = self
            locationManager.startUpdatingLocation()
            isAnyEventActivated = true
            activatedEvent = "Personalizado"
            msgCount = 0
            if (eventDict["eventDuration"] as! String) != "1/2" {
                numberOfMsgsToSend = Int(eventDict["eventDuration"] as! String)!*60/Int(eventDict["msgFreq"] as! String)!
            }
            else {
                numberOfMsgsToSend = 30 / Int(eventDict["msgFreq"] as! String)!
            }
            
            deCaminoAlert = UIAlertController(title: "Alerta activada", message: "Su mensaje '\(activatedEvent ?? "")' se está enviando cada \(eventDict["msgFreq"] ?? "") minutos. Usted puede extender la duración del evento o desactivarlo.", preferredStyle: .alert)

            deCaminoAlert?.addAction(UIAlertAction(title: "Extender por 30 minutos", style: .default, handler: { action in
                let msgFreq = self.eventDict["msgFreq"] as! Int
                self.numberOfMsgsToSend! += 30/msgFreq
            }))
            deCaminoAlert?.addAction(UIAlertAction(title: "Desactivar", style: .cancel, handler: { action in
                self.locationManager.stopUpdatingLocation()
                self.locationManager.delegate = nil
                self.msgCount = 0
                self.isAnyEventActivated = false
                print("Personalizado event deactivated.")
            }))
            
            self.present(deCaminoAlert!, animated: true)

        }
        else if activatedEvent == "Personalizado" {
            locationManager.stopUpdatingLocation()
            locationManager.delegate = nil
            msgCount = 0
            isAnyEventActivated = false
            deCaminoAlert?.dismiss(animated: true, completion: nil)
            print("Personalizado event deactivated.")
        }
        else {
            print("Event: \(String(describing: activatedEvent)) is activated.")
        }
    }
    
    
    // MARK: - Send Message
    func sendMsg() {
        let text = eventDict["msg"] as! String
        let riskLevel = eventDict["riskLevel"] as! String
        // let duration = eventDict["eventDuration"]
        let freq = eventDict["msgFreq"] as! String
        let user = defaults.string(forKey: "user")!
        var msg = "Esto es un mensaje automatizado de Pa'SOS. \(user) le ha enviado una alerta:\n\(String(describing: text))\n\(String(describing: riskLevel))\nRecibirá un mensaje cada \(String(describing: freq)) minutos."
        
        let pref = eventDict["locationPref"] as! Bool
        if pref == true {
            var gmapsPin = "https://maps.google.com/?q="
            gmapsPin += "\(Double(lastLocation?.latitude ?? 0)),\(Double(lastLocation?.longitude ?? 0))"
            msg += "\nÚltima ubicación: " + gmapsPin
        }
        
        print(msg)
        
        // to server
        
        
        let contactsDict = defaults.object(forKey: "contacts") as? [String: String] ?? [String: String]()
        let contacts = Array(contactsDict.keys)
        
        let parameters: [String: Any] = ["msg": msg, "contacts": contacts.description]
    
        //create the url with URL
        let url = URL(string: "http://136.145.231.45/pasos_server.php")!

        //create the session object
        let session = URLSession.shared

        //now create the URLRequest object using the url object
        var request = URLRequest(url: url)
        request.httpMethod = "POST" //set http method as POST

        request.httpBody = parameters.percentEncoded()

        request.addValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")

//        request.log()
        
        //create dataTask using the session object to send data to the server
        let task = session.dataTask(with: request, completionHandler: { data, response, error in

            guard error == nil else {
                return
            }
            
            if let response = response {
                let nsHTTPResponse = response as! HTTPURLResponse
                let statusCode = nsHTTPResponse.statusCode
                print ("status code = \(statusCode)")
            }
            
        })
        task.resume()
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        
        locationManager.delegate = self
        locationManager.allowsBackgroundLocationUpdates = true
        
        if CLLocationManager.authorizationStatus() == .notDetermined {
            locationManager.requestAlwaysAuthorization()
        }
        
        if CLLocationManager.locationServicesEnabled() {
            locationManager.desiredAccuracy = kCLLocationAccuracyBest
        }
        else {
            print("Location services are disabled.")
        }
        emptyContactsAlert.addAction(UIAlertAction(title: "Ok", style: .default, handler: nil))
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        self.navigationItem.hidesBackButton = true
    }

    @IBAction func didTapMenu(_ sender: UIBarButtonItem) {
        guard let menuViewController = storyboard?.instantiateViewController(withIdentifier: "MenuViewController") as? MenuViewController else { return }
        
        menuViewController.modalPresentationStyle = .overCurrentContext
        menuViewController.transitioningDelegate = self
        present(menuViewController, animated: true)
    }
    
}

extension HomeViewController: UIViewControllerTransitioningDelegate, CLLocationManagerDelegate {
    func animationController(forPresented presented: UIViewController, presenting: UIViewController, source: UIViewController) -> UIViewControllerAnimatedTransitioning? {
        transition.isPresenting = true
        return transition
    }
    func animationController(forDismissed dismissed: UIViewController) -> UIViewControllerAnimatedTransitioning? {
        transition.isPresenting = false
        return transition
    }
    // MARK: Handle Location
    func locationManager(_ manager: CLLocationManager, didUpdateLocations locations: [CLLocation]) {
        let now = Date()
        // get location for first msg
        if msgCount == 0 {
            lastLocation = manager.location?.coordinate
            lastUpdateTime = now
            sendMsg()
            msgCount! += 1
        }
        // check if freq is met
        else if now.timeIntervalSince(lastUpdateTime!) >= Double(eventDict["msgFreq"] as! String)!*60 {
            
            locationManager.desiredAccuracy = kCLLocationAccuracyBest
            do {
                sleep(5)
            }
            // get location after some time to get better accuracy
            lastLocation = manager.location?.coordinate
            lastUpdateTime = now
            locationManager.desiredAccuracy = kCLLocationAccuracyKilometer
            sendMsg()
            msgCount! += 1
            print(msgCount!)
        }
        
        if msgCount! >= numberOfMsgsToSend! {
            switch activatedEvent {
            case "De camino":
                deCaminoBtn.sendActions(for: .touchUpInside)
            default:
                break
            }
        }
        
        print(Date())
    }
}

// DEBUG

extension Data {
    func toString() -> String? {
        return String(data: self, encoding: .utf8)
    }
}

extension URLRequest {
    func log() {
        print("\(httpMethod ?? "") \(self)")
        print("BODY \n\(httpBody?.toString() ?? "")")
        print("HEADERS \n\(allHTTPHeaderFields ?? [:])")
    }
}

extension Dictionary {
    func percentEncoded() -> Data? {
        return map { key, value in
            let escapedKey = "\(key)".addingPercentEncoding(withAllowedCharacters: .urlQueryValueAllowed) ?? ""
            let escapedValue = "\(value)".addingPercentEncoding(withAllowedCharacters: .urlQueryValueAllowed) ?? ""
            return escapedKey + "=" + escapedValue
        }
        .joined(separator: "&")
        .data(using: .utf8)
    }
}

extension CharacterSet {
    static let urlQueryValueAllowed: CharacterSet = {
        let generalDelimitersToEncode = ":#[]@" // does not include "?" or "/" due to RFC 3986 - Section 3.4
        let subDelimitersToEncode = "!$&'()*+,;="

        var allowed = CharacterSet.urlQueryAllowed
        allowed.remove(charactersIn: "\(generalDelimitersToEncode)\(subDelimitersToEncode)")
        return allowed
    }()
}
