//
//  MainViewController.swift
//  app
//
//  Created by Luis Quiñones  on 10/30/19.
//  Copyright © 2019 Luis Quiñones . All rights reserved.
//

import UIKit

class MainViewController: UIViewController {

    
    let defaults = UserDefaults.standard
    var toSaveDict: [String:Any] = [:]
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        setDefaults()
        // Do any additional setup after loading the view.
    }
    
    override func viewDidAppear(_ animated: Bool) {
        if isAppAlreadyLaunchedOnce() {
            self.performSegue(withIdentifier: "mainToHome", sender: self)
        }
        else {
            self.performSegue(withIdentifier: "mainToFirstTime", sender: self)
        }
    }
    
    func isAppAlreadyLaunchedOnce()->Bool{
        if let _ = defaults.string(forKey: "isAppAlreadyLaunchedOnce"){
            return true
        }else{
            defaults.set(true, forKey: "isAppAlreadyLaunchedOnce")
            return false
        }
    }
    func setDefaults() {
        
        // Set default and first custom forms
        
        if !defaults.contains(key: "deCaminoDefault") {
            toSaveDict["title"] = "De camino"
            toSaveDict["msg"] = "Voy de regreso a casa."
            toSaveDict["riskLevel"] = "No veo riesgo al momento."
            toSaveDict["eventDuration"] = "1/2"
            toSaveDict["msgFreq"] = "5"
            toSaveDict["locationPref"] = true
            defaults.set(toSaveDict, forKey: "deCaminoDefault")
            defaults.set(toSaveDict, forKey: "deCamino")
//            print("Set deCaminoDefault dictionary of inputs")
        }
        
        if !defaults.contains(key: "soleaoDefault") {
            toSaveDict["title"] = "Ando soleá/o"
            toSaveDict["msg"] = "Estoy caminando sola/o por la calle."
            toSaveDict["riskLevel"] = "No veo riesgo al momento."
            toSaveDict["eventDuration"] = "1/2"
            toSaveDict["msgFreq"] = "5"
            toSaveDict["locationPref"] = true
            defaults.set(toSaveDict, forKey: "soleaoDefault")
            defaults.set(toSaveDict, forKey: "soleao")
//            print("Set soleaoDefault dictionary of inputs")
        }

        if !defaults.contains(key: "aPieDefault") {
            toSaveDict["title"] = "Estoy quedá/o"
            toSaveDict["msg"] = "Me quedé a pie."
            toSaveDict["riskLevel"] = "No veo riesgo al momento."
            toSaveDict["eventDuration"] = "1/2"
            toSaveDict["msgFreq"] = "5"
            toSaveDict["locationPref"] = true
            defaults.set(toSaveDict, forKey: "aPieDefault")
            defaults.set(toSaveDict, forKey: "aPie")
//            print("Set aPieDefault dictionary of inputs")
        }
        
        if !defaults.contains(key: "Personalizado") {
            toSaveDict["title"] = "Personalizado"
            toSaveDict["msg"] = ""
            toSaveDict["riskLevel"] = ""
            toSaveDict["eventDuration"] = ""
            toSaveDict["msgFreq"] = ""
            toSaveDict["locationPref"] = true
            defaults.set(toSaveDict, forKey: "personalizado")
//            print("Set aPieDefault dictionary of inputs")
        }
    }

    
}
