//
//  MensajesViewController.swift
//  app
//
//  Created by Luis Quiñones  on 11/30/19.
//  Copyright © 2019 Luis Quiñones . All rights reserved.
//

import UIKit

class MessagesViewController: UIViewController {

    let transition = SlideInTransition()
    var topView: UIView?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        self.navigationItem.hidesBackButton = true
    }

    @IBAction func didTapMenu(_ sender: UIBarButtonItem) {
        guard let menuViewController = storyboard?.instantiateViewController(withIdentifier: "MenuViewController") as? MenuViewController else { return }
        
        menuViewController.modalPresentationStyle = .overCurrentContext
        menuViewController.transitioningDelegate = self
        present(menuViewController, animated: true)
    }
    

    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        
        if let formVC: MsgsFormViewController = segue.destination as? MsgsFormViewController {
            formVC.event = segue.identifier
            formVC.defaultEvent = (segue.identifier ?? "") + "Default"
        }
        else if let formVC: CustomMsgFormViewController = segue.destination as? CustomMsgFormViewController {
            formVC.event = segue.identifier
        }
    }
    
}

extension MessagesViewController: UIViewControllerTransitioningDelegate {
    func animationController(forPresented presented: UIViewController, presenting: UIViewController, source: UIViewController) -> UIViewControllerAnimatedTransitioning? {
        transition.isPresenting = true
        return transition
    }
    func animationController(forDismissed dismissed: UIViewController) -> UIViewControllerAnimatedTransitioning? {
        transition.isPresenting = false
        return transition
    }
}


