//
//  TableWithMenuViewController.swift
//  app
//
//  Created by Luis Quiñones  on 12/15/19.
//  Copyright © 2019 Luis Quiñones . All rights reserved.
//

import UIKit

class TableWithMenuViewController: UITableViewController {

    let transition = SlideInTransition()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.navigationItem.hidesBackButton = true
        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem
    }

   @IBAction func didTapMenu(_ sender: UIBarButtonItem) {
       guard let menuViewController = storyboard?.instantiateViewController(withIdentifier: "MenuViewController") as? MenuViewController else { return }
       
       menuViewController.modalPresentationStyle = .overCurrentContext
       menuViewController.transitioningDelegate = self
       present(menuViewController, animated: true)
   }

}

extension TableWithMenuViewController: UIViewControllerTransitioningDelegate {
    func animationController(forPresented presented: UIViewController, presenting: UIViewController, source: UIViewController) -> UIViewControllerAnimatedTransitioning? {
        transition.isPresenting = true
        return transition
    }
    func animationController(forDismissed dismissed: UIViewController) -> UIViewControllerAnimatedTransitioning? {
        transition.isPresenting = false
        return transition
    }
}
